#include <cstdlib>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <cstring>
#include <string.h>
#include <time.h>

#include "shape.h"
#include "shape_generation.h"
#include "tree_generation.h"

using namespace std;

/// SHAPE DATABASE REPOSITORY NAMES
#define NumberOfDataBases 4
char DataBaseName[NumberOfDataBases][300]={
  "TriangulationDataBase/FormasAbstractas/",
  "TriangulationDataBase/Mattise/",
  "TriangulationDataBase/LaMano/",
  "TriangulationDataBase/Tarkett/"
};
char PaletteDataBaseName[200]="PaletteDataBase/";

int main(int argc, char *argv[])
{
  char data[400]="./data2";

  /// WE READ SHAPE DATABASE
  vector < vector<shape> > ShapeDataBaseV(NumberOfDataBases);
  for(int k=0;k<NumberOfDataBases;k++){
    char name[400];
    sprintf(name,"%s/%s",data,DataBaseName[k]);
    printf("name=%s\n",name);
    ReadShapeDataBase(ShapeDataBaseV[k],name);
    printf("Number of shapes in database = %d\n",ShapeDataBaseV[k].size());
    if(ShapeDataBaseV[k].size()==0){
      printf("Problems reading shape database : %s \n",DataBaseName[k]);
      { int ii_; scanf("%d",&ii_);} //
      return(-1);
    }
  }

  /// WE READ PALETTE DATABASE
  vector<imageBMP> PaletteDataBase;
  {
    char name[400];
    sprintf(name,"%s/%s",data,PaletteDataBaseName);
    ReadPaletteDataBase(PaletteDataBase,name);
    if(PaletteDataBase.size()==0){
      printf("Problems reading palette database : %s \n",PaletteDataBaseName);
      { int ii_; scanf("%d",&ii_);} //
      return(-1);
    }
  }

  /// WE READ THE PARAMETER FILE FOR SHAPE GENERATION
  float zoom=800.;
  int OrderToDrawShapes;
  float scale;
  float width_float=1.; //1.413793;
  float height_float=1.;
  string DefaultPalette("*");
  vector<float> border_thick;
  vector<color> background_color;
  vector<tree_node_generator_parameters> TngpV;
  shape S;
  bool periodicity=false;

  for(int k=0;k<1000;k++){
   clock_t t=clock();
   printf("\n");
   srand (time(NULL));
   if(argc==2){
    read_image_configuration_parameters(argv[1],S,width_float,height_float,border_thick,background_color,zoom,TngpV,OrderToDrawShapes,scale,DefaultPalette);
    //rand();
   }
   else{
    S=RandomShapeParameterConfiguration(width_float,height_float,border_thick,background_color,
                                      TngpV,PaletteDataBase,rand()%PaletteDataBase.size(),OrderToDrawShapes,scale,periodicity);

//    for(int k=0;k<TngpV.size();k++){
//     TngpV[k].palette_index=TngpV[k].palette_index%PaletteDataBase.size();
//     if(TngpV[k].tesselation_palette_index>=0)
//        TngpV[k].tesselation_palette_index=TngpV[k].tesselation_palette_index%PaletteDataBase.size();
//    }
//    for(int k=0;k<background_color.size();k++){
//      if(TngpV[0].tesselation_palette_index>=0){
//        background_color[k]=PaletteDataBase[TngpV[0].tesselation_palette_index][rand()%PaletteDataBase[TngpV[0].tesselation_palette_index].size()];
//      }
//      else{
//        background_color[k]=PaletteDataBase[TngpV[0].palette_index][rand()%PaletteDataBase[TngpV[0].palette_index].size()];
//      }
//    }
    //S.c=background_color[0];
//    for(int k=0;k<S.shapeChild.size();k++ ) S.shapeChild[k].c=background_color[k];
   }
   vector<tree_node_generator_parameters> TngpV0=TngpV;

  //write_image_configuration_parameters("shapeTree2.info",S,width_float,height_float,border_thick,background_color,zoom,TngpV); //system("pause");

//  read_image_configuration_parameters(nameParams,S,width_float,height_float,border_thick,background_color,zoom,TngpV,OrderToDrawShapes,scale,DefaultPalette);

//printf("ok4\n");

  printf("SHAPE GENERATION FROM TREE NODES\n");
  tree_generator(S,ShapeDataBaseV,PaletteDataBase,TngpV,scale);
//   for(int k=0;k<TngpV.size();k++){
//     if(scale>1e-20){
//        TngpV[k].shape_diameter*=scale;
//        TngpV[k].border_thick*=scale;
//     }
//     printf("k=%d Nnodes=%d  node  ",k,TngpV.size());
//     for(int m=0;m<TngpV[k].nodes.size()-1;m++) printf("%d:",TngpV[k].nodes[m]);
//     printf("%d  shape_diameter=%lf\n",TngpV[k].nodes[TngpV[k].nodes.size()-1],TngpV[k].shape_diameter);
//     TngpV[k].tree_node_generator(S,ShapeDataBaseV,PaletteDataBase);
//  }
  int TimeSec1=(((float)clock()-t)/CLOCKS_PER_SEC);
  t=clock();
  printf("WE DRAW THE SHAPE TREE IN AN IMAGE IN BMP FORMAT\n");
  int width=zoom*width_float;
  int height=zoom*height_float;
  width=4*(width/4);
  height=4*(height/4);
  imageBMP I(width,height,color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255));
  //if(TngpV.size()>0) srand(TngpV[0].palette_index);

  draw_shape(S,I,1/zoom,PaletteDataBase,OrderToDrawShapes,periodicity);

  /// WE APPLY A FILTER TO THE IMAGE
//  morphological_erosion2D(I,1);
//  morphological_dilation2D(I,1);
//  morphological_erosion2D(I,1);
//  morphological_dilation2D(I,1);

  /// WE WRITE THE IMAGE AND INFO FILES
  char name1[200],name2[200],name3[200],name4[200],nameParams[200],name5[200],name6[200];
  char name[200];
  ami_date_name(name);
  int TimeSec2=(((float)clock()-t)/CLOCKS_PER_SEC);
  sprintf(name1,"%s_%d_%d.bmp",name,TimeSec1,TimeSec2);
  sprintf(name2,"%s_%d_%dsym.bmp",name,TimeSec1,TimeSec2);
  sprintf(name3,"%s_%d_%dBW.bmp",name,TimeSec1,TimeSec2);
  sprintf(name4,"%s_%d_%dBWsym.bmp",name,TimeSec1,TimeSec2);
  sprintf(name5,"%s_%d_%dBIN.bmp",name,TimeSec1,TimeSec2);
  sprintf(name6,"%s_%d_%dBINsym.bmp",name,TimeSec1,TimeSec2);
  sprintf(nameParams,"%s_%d_%d.info",name,TimeSec1,TimeSec2);
  write_image_configuration_parameters(nameParams,S,width_float,height_float,border_thick,background_color,zoom,TngpV0,OrderToDrawShapes,scale,DefaultPalette);

  printf("WE CLEAR SHAPE\n");
  S.clear();
  printf("WE WRITE ORIGINAL IMAGE\n");
  I.write(name1);
  if(periodicity==true){
    I=I.zoom(0.5);
    imageBMP I2=I.joint(I);
    imageBMP I3=I2.jointV(I2);
    I3.write(name2);
  }

//  /// WE TRANSFORM IMAGES TO BLACK AND WHITE
//  vector < vector < vector<color> > > TessPalette(256,vector< vector < color > >(256,vector < color >(256)));
//  for(int i=0;i<256;i++){
//    for(int j=0;j<256;j++){
//      for(int k=0;k<256;k++){
////        TessPalette[i][j][k]= ((double) rand()/RAND_MAX)<0.5?color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0):
////          color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
//
//
//      }
//    }
//  }
//  TessPalette[255][255][255]=color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
//  TessPalette[0][0][0]=color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0);
//
//  for(int k=0;k<I.size();k++){
//    I[k]=TessPalette[I[k].R_][I[k].G_][I[k].B_];
//  }
//  I.write(name3);


//  /// WE TRANSFORM IMAGES TO BLACK AND WHITE
//  vector < vector < vector<color> > > TessPalette(256,vector< vector < color > >(256,vector < color >(256)));
//  for(int i=0;i<256;i++){
//    for(int j=0;j<256;j++){
//      for(int k=0;k<256;k++){
//        TessPalette[i][j][k]= ((double) rand()/RAND_MAX)<0.5?color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0):
//          color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
//      }
//    }
//  }
//  TessPalette[255][255][255]=color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
//  TessPalette[0][0][0]=color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0);
//
//  for(int k=0;k<I.size();k++){
//    I[k]=TessPalette[I[k].R_][I[k].G_][I[k].B_];
//  }
//  I.write(name3);

  printf("IMAGE WITH 45 SYMMETRY\n");
  imageBMP I2=I.symmetry45();
  I2.write(name2);

  I2=imageBMP(I.width(),I.height());

  printf("WE TRANSFORM IMAGES TO BLACK AND WHITE\n");
  vector < vector < vector<color> > > TessPalette(256,vector< vector < color > >(256,vector < color >(256)));
  for(int i=0;i<256;i++){
    for(int j=0;j<256;j++){
      for(int k=0;k<256;k++){
        //TessPalette[i][j][k]= ((double) rand()/RAND_MAX)<0.5?color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0):
        //color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
        unsigned char c=rand()%255;
        TessPalette[i][j][k]= color(c,c,c);
      }
    }
  }
  TessPalette[255][255][255]=color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
  TessPalette[0][0][0]=color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0);

  for(int k=0;k<I.size();k++){
    I2[k]=TessPalette[I[k].R_][I[k].G_][I[k].B_];
  }
  I2.write(name3);

  printf("IMAGE WITH 45 SYMMETRY\n");
  I2=I2.symmetry45();
  I2.write(name4);

  I2=imageBMP(I.width(),I.height());

  for(int i=0;i<256;i++){
    for(int j=0;j<256;j++){
      for(int k=0;k<256;k++){
        TessPalette[i][j][k]= ((double) rand()/RAND_MAX)<0.5?color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0):
        color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
        //unsigned char c=rand()%255;
        //TessPalette[i][j][k]= color(c,c,c);
      }
    }
  }
  TessPalette[255][255][255]=color((unsigned char) 255,(unsigned char) 255,(unsigned char) 255);
  TessPalette[0][0][0]=color((unsigned char) 0,(unsigned char) 0,(unsigned char) 0);

  for(int k=0;k<I.size();k++){
    I2[k]=TessPalette[I[k].R_][I[k].G_][I[k].B_];
  }
  I2.write(name5);

  printf("IMAGE WITH 45 SYMMETRY\n");
  I2=I2.symmetry45();
  I2.write(name6);


   if(argc==2) break;
  }
}
